@echo off

REM *** Set Notepad++ as your default text editor ***
REM Author: Robert Sauve
REM Sauve Consulting
REM https://www.sauveconsulting.com.au/

REM *** Changing working folder back to current directory ***
%~d0
CD %~dp0

REM *** Display error level codes ***
REM IF %ERRORLEVEL% NEQ 0 SET RESULT=%ERRORLEVEL%
REM Echo %ERRORLEVEL%
REM pause

REM *** Test for elevated administrator privileges ***
net session >nul 2>&1
if ERRORLEVEL 2 (
echo.
echo ERROR! You must have elevated administrator privileges.
echo.
echo For Win 2000/XP users....
echo Log ino a Windows user account with Administrator privileges
echo or log into the Administrator account.
echo.
echo For Win Vista/7/8/8.1/10 users....
echo Right mouse click on the file and select "Run as administrator".
echo Try again....
echo.
echo Press any key to end.
Pause >nul
exit /b 1
)

REM *** Check if notepad++ has been patched ***
if exist %windir%\system32\notepad.exe.bak (
echo.
echo Notepad++ is already patched.
echo Run RestoreNotepad.bat to restore original Notepad and try again...
echo.
echo Press any key to end.
Pause >nul
exit /b 1
)

REM *** Take ownership of notepad.exe ***
if exist %windir%\notepad.exe (
if exist %windir%\system32\takeown.exe takeown /f %windir%\notepad.exe
cacls %windir%\notepad.exe /E /G Administrators:F
)
if exist %windir%\system32\notepad.exe (
if exist %windir%\system32\takeown.exe takeown /f %windir%\system32\notepad.exe
cacls %windir%\system32\notepad.exe /E /G Administrators:F
)
if exist %windir%\SysWOW64 (
if exist %windir%\system32\takeown.exe takeown /f %windir%\SysWOW64\notepad.exe
cacls %windir%\SysWOW64\notepad.exe /E /G Administrators:F
)

REM *** copy notpad++ executables to user temp folder ***
copy /B /Y notepad.exe %temp%\. >NUL
copy /B /Y notepad64.exe %temp%\. >NUL

REM *** Backup Notepad.exe in general OS locations ***
if not exist %windir%\notepad.exe.bak rename %windir%\notepad.exe notepad.exe.bak
if not exist %windir%\system32\notepad.exe.bak rename  %windir%\system32\notepad.exe notepad.exe.bak
REM *** Rename for 32 bit OS ***
if exist %windir%\system32\dllcache if not exist %windir%\system32\dllcache\notepad.exe.bak rename %windir%\system32\dllcache\notepad.exe notepad.exe.bak
REM *** Backup Notepad.exe in 64 bit OS ***
if exist %windir%\SysWOW64 if not exist %windir%\SysWOW64\notepad.exe.bak rename %windir%\SysWOW64\notepad.exe notepad.exe.bak

REM *** Backup Notepad.exe in Service Pack installation ***
if exist %windir%\ServicePackFiles\i386 if not exist %windir%\ServicePackFiles\i386\notepad.exe.bak rename %windir%\ServicePackFiles\i386\notepad.exe notepad.exe.bak

REM *** Copy Notepad++ to 32bit or 64bit OS locations ***
echo.
copy /B /Y %temp%\notepad.exe %windir%\system32\
copy /B /Y %temp%\notepad.exe %windir%\
if exist %windir%\system32\dllcache copy /B /Y %temp%\notepad.exe %windir%\system32\dllcache\

REM *** Copy Notepad++ to 64 bit OS location ***
if exist %windir%\SysWOW64 copy /B /Y %temp%\notepad64.exe %windir%\SysWOW64\notepad.exe

REM *** Copy Notepad++ Service Pack installation ***
if exist %windir%\ServicePackFiles\i386 copy /B /Y %temp%\notepad.exe %windir%\ServicePackFiles\i386

REM *** Cleanup old files ***
del /Q %temp%\notepad.exe >NUL
del /Q %temp%\notepad64.exe >NUL

echo.
echo All done.
Pause
